HDU 5773 The All-purpose Zero (DP)

来源:互联网 发布:京东货到付款拒收 知乎 编辑:程序博客网 时间:2024/05/29 14:24

The All-purpose Zero

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 112    Accepted Submission(s): 44


Problem Description
?? gets an sequence S with n intergers(0 < n <= 100000,0<= S[i] <= 1000000).?? has a magic so that he can change 0 to any interger(He does not need to change all 0 to the same interger).?? wants you to help him to find out the length of the longest increasing (strictly) subsequence he can get.
 

Input
The first line contains an interger T,denoting the number of the test cases.(T <= 10)
For each case,the first line contains an interger n,which is the length of the array s.
The next line contains n intergers separated by a single space, denote each number in S.
 

Output
For each test case, output one line containing “Case #x: y”(without quotes), where x is the test case number(starting from 1) and y is the length of the longest increasing subsequence he can get.
 

Sample Input
272 0 2 1 2 0 561 2 3 3 0 0
 

Sample Output
Case #1: 5Case #2: 5
Hint
In the first case,you can change the second 0 to 3.So the longest increasing subsequence is 0 1 2 3 5.
 

Author
FZU
 

Source
2016 Multi-University Training Contest 4
 

Recommend
wange2014   |   We have carefully selected several similar problems for you:  5775 5774 5772 5771 5770

题目大意:
    输入一个整数序列,其中0可以替换成 任意一个整数。求最大严格上升子序列。

解题思路:
    如果0不可以换,那么就是一个LIS问题,可是如果0可以替换那么就不能直接dp了。因为0可以换成任意一个数,所以我们可以先把0取出,对剩下的进行LIS,最后再把0的个数加上,不过这样不能保证严格递增。所以,我们需要将每一个非0点数字减去它前面0的个数,再进行LIS就可以保证加入0后也是严格递增的了。

附AC代码:
#include <iostream>#include <cstdio>#include <algorithm>#include <cstring>#include <queue>#include <vector>using namespace std;#define INF 0x3f3f3f3fconst int maxn=100000+5;int a[maxn],dp[maxn];int main(){    int T;    scanf("%d",&T);    for(int tt=1;tt<=T;++tt)    {        int n,num=0;        scanf("%d",&n);        for(int i=0;i<n;++i)        {            scanf("%d",&a[i]);            if(a[i]==0)//去掉0            {                ++num;                --n;                --i;            }            else a[i]-=num;//减去前面0的个数        }        memset(dp,0x3f,sizeof dp);        for(int i=0;i<n;++i)//O(n * log n)的LIS            *lower_bound(dp, dp+n, a[i])=a[i];        printf("Case #%d: %d\n",tt,(int)(lower_bound(dp, dp+n, INF)-dp)+num);    }        return 0;}


0 0
原创粉丝点击